/************************************************************************/
//		plug-in for internet browser ( mozilla / netscape )
//		send enbled url to downloader gsfdm through corba bus

//		tool for configuration...



//		j.a.l@free.fr

/************************************************************************/

#include	<gtk/gtk.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<signal.h>
#include	<sys/wait.h>
#include	<sys/types.h>
#include	<bits/types.h>

#include	"config.h"

/************************************************************************/

#define MIME_TYPE_KEY "mime_type_entry"
#define SUFFIXES_LIST_KEY "suffixes_list_entry"
#define	DESCRIPTION_KEY "descrition_entry"
#define	MIME_ST_KEY "mime_st_struct"

typedef	struct mime_st {
	gchar		*type;
	gchar		*suffixes;
	gchar		*desc;
	gboolean	edited;
} mime_st;

#define MIME_ST( s ) ( ((mime_st *)s) )
#define mime_st_type( s ) ( MIME_ST( s )->type )
#define mime_st_suffixes( s ) ( MIME_ST( s )->suffixes )
#define mime_st_desc( s ) ( MIME_ST( s )->desc )
#define mime_st_edited( s ) ( MIME_ST( s )->edited )

#define	mime_st_new() ( MIME_ST( g_new0( mime_st, 1 ) ) )

#define mime_st_destroy( s ) G_STMT_START{	\
	if( mime_st_type( s ) )					\
		g_free( mime_st_type( s ) );		\
	if( mime_st_suffixes( s ) )				\
		g_free( mime_st_suffixes( s ) );	\
	if( mime_st_desc( s ) )					\
		g_free( mime_st_desc( s ) );		\
	g_free( s ); }G_STMT_END
	
	
#define	STR_LENGTH	2000
#define	GBP_MIME_TOKEN "MIME="
#define	GBP_MIME_TOKEN_SIZE 5
	
#define GBP_DLG_TOKEN "DLG="
#define GBP_DLG_TOKEN_SIZE 4

#define	TEXT_INFO	"This is the configuration tool for browser plugin \"gsfdm_browser_plug\"\n"
gchar	*title[] = { "Type" , "Suffixes", NULL };
#define	COL_TYPE		0
#define	COL_SUFFIXES	1
	
GtkCList		*list;
GtkCheckButton	*use_gnome;
GtkButton		*bp_help, *bp_submit;
GtkButton		*bp_add, *bp_delete, *bp_edit;

extern gchar	*default_type[];
extern gchar	*default_suffixe[];
extern gchar	*default_desc[]; 
	
/************************************************************************/
static gboolean	real_add_mime( mime_st *s )
{
gint	row;
gchar	*text[] = { NULL, NULL, NULL };

	if( !mime_st_type( s ) )
		return( FALSE );

	if( !mime_st_suffixes( s ) )
		mime_st_suffixes( s ) = g_strdup( "*" );

	if( !strlen( mime_st_suffixes( s ) ) )
		mime_st_suffixes( s ) = g_strdup( "*" );
	
	// check if already in list
	for( row = 0 ; row < list->rows ; row++ )
	{	gtk_clist_get_text( list, row, COL_SUFFIXES, &text[COL_TYPE] );
		
		if( !strcmp( text[COL_TYPE], mime_st_type( s ) ) )
			return( FALSE );			// already in list
	}
	
	// can add
	text[COL_TYPE] = mime_st_type( s );
	text[COL_SUFFIXES] = mime_st_suffixes( s );
	row = gtk_clist_append( list, text );
	gtk_clist_set_row_data( list, row, (gpointer)s );
	
	return( TRUE );
}
	
/************************************************************************/
static gboolean  load_config()
{
FILE	*f;
gchar	*path = g_strconcat( getenv( "HOME" ), "/", PACKAGE_CONFIG_FILENAME, NULL );
gchar	*str;
gchar	*ptr;
size_t	str_size = STR_LENGTH;
	
	if( !( f = fopen( path, "r" ) ) )
	{	g_free( path );
		return( FALSE );
	}
	
	str = g_new0( gchar, str_size );
	
	while( getline( &str, &str_size, f ) != -1 )
	{	// search for first '\n' --> end of line
		if( ( ptr = strchr( str, '\n' ) ) )
			*ptr = 0;
		
		if( strstr( str, GBP_MIME_TOKEN ) )
		{	gchar	*token;
			mime_st	*s = mime_st_new();
			
			strtok( str, "=:" );				// token
			mime_st_type( s ) = g_strdup( strtok( NULL, "=:" ) );
			mime_st_suffixes( s ) = g_strdup( strtok( NULL, "=:" ) );
			mime_st_desc( s ) = g_strdup( strtok( NULL, "=:" ) );
			real_add_mime( s );
			
		} else if( strstr( str, GBP_DLG_TOKEN ) )
		{	// token for type of message, dlg or statusbar
			gtk_toggle_button_set_active( GTK_TOGGLE_BUTTON( use_gnome ), 
				(gboolean)strtol( ( str + GBP_DLG_TOKEN_SIZE ), NULL, 10 ) );
		}
	}
	
	gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), FALSE );

	fclose( f );
	g_free( str );
	g_free( path );
	return( TRUE );
}

/************************************************************************/
static void save_config()
{
FILE	*f;
gchar	*path = g_strconcat( getenv( "HOME" ), "/", PACKAGE_CONFIG_FILENAME".tmp", NULL );
gchar	*path2;
gchar	*t, *sf, *d;
mime_st	*s;
gint	row;
	
	if( !( f = fopen( path, "w+" ) ) )
	{	g_free( path );
		g_warning( "can't write tmp config file ???" );
		return;
	}
	
	// write mime
	for( row = 0 ; row < list->rows ; row++ )
	{	s = MIME_ST( gtk_clist_get_row_data( list, row ) );
		
		fprintf( f, GBP_MIME_TOKEN"%s:%s:%s\n",
			mime_st_type( s ), mime_st_suffixes( s ), mime_st_desc( s )	);
	}
	
	// write global option
	fprintf( f, GBP_DLG_TOKEN"%d\n", gtk_toggle_button_get_active( GTK_TOGGLE_BUTTON( use_gnome ) ) );
	
	fflush( f );
	fclose( f );
	
	// swap files
	path2 = g_strconcat( getenv( "HOME" ), "/", PACKAGE_CONFIG_FILENAME, NULL );
	unlink( path2 );
	rename( path, path2 );
	
	g_free( path );
	g_free( path2 );
	
	gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), FALSE );
}

/************************************************************************/
static void init_config()
{
gint	index = 0;
mime_st	*s;
	
	while( default_type[ index ] )
	{	s = mime_st_new();
		
		mime_st_type( s ) = g_strdup( default_type[ index ] );
		mime_st_suffixes( s ) = g_strdup( default_suffixe[ index ] );
		mime_st_desc( s ) = g_strdup( default_desc[ index ] );
		
		if( !real_add_mime( s ) )
			mime_st_destroy( s );
		
		index++;
	}
	
	gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), TRUE );
}

/************************************************************************/
static void exit_window_yes( GtkWindow *ww )
{
	save_config();
	gtk_main_quit();
}

/************************************************************************/
static void exit_window( GtkWidget *w )
{
	if( GTK_WIDGET_IS_SENSITIVE( bp_submit ) )
	{	GtkWindow	*ww = GTK_WINDOW( gtk_window_new( GTK_WINDOW_DIALOG ) );
		GtkWidget	*b = gtk_vbox_new( FALSE, 5 );
		GtkWidget	*b2 = gtk_hbox_new( TRUE, 5 );
		GtkWidget	*bp;
		
		gtk_container_add( GTK_CONTAINER( ww ), b );
		gtk_box_pack_start( GTK_BOX( b ) , gtk_label_new( "Save before exit ???" ), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( b ) , gtk_hseparator_new(), FALSE, FALSE, 5 );
		gtk_box_pack_start( GTK_BOX( b ) , b2, FALSE, FALSE, 5 );
		
		bp = gtk_button_new_with_label( "Yes" );
		gtk_box_pack_start( GTK_BOX( b2 ), bp, FALSE, FALSE, 5 );
		gtk_signal_connect_object( GTK_OBJECT( bp ), "clicked", GTK_SIGNAL_FUNC( exit_window_yes ), (gpointer)ww );

		bp = gtk_button_new_with_label( "NO" );
		gtk_signal_connect_object( GTK_OBJECT( bp ), "clicked", GTK_SIGNAL_FUNC( gtk_widget_destroy ), (gpointer)w );
		gtk_box_pack_start( GTK_BOX( b2 ), bp, FALSE, FALSE, 5 );

		bp = gtk_button_new_with_label( "CANCEL" );
		gtk_signal_connect_object( GTK_OBJECT( bp ), "clicked", GTK_SIGNAL_FUNC( gtk_widget_destroy ), (gpointer)ww );
		gtk_box_pack_start( GTK_BOX( b2 ), bp, FALSE, FALSE, 5 );

		gtk_signal_connect( GTK_OBJECT( ww ), "destroy", GTK_SIGNAL_FUNC( gtk_widget_destroy ), NULL );
		gtk_signal_connect( GTK_OBJECT( ww ), "delete_event", GTK_SIGNAL_FUNC( gtk_widget_destroy ), NULL );

		gtk_widget_show_all( GTK_WIDGET( ww ) );
		return;
	}
	
	// already update
	gtk_main_quit();
}

/************************************************************************/
// submit change to list
static void save_popup_mime_view( GtkWindow *ww )
{
mime_st	*s;
gchar	*m, *sf, *d;
	
	s = MIME_ST( gtk_object_get_data( GTK_OBJECT( ww ), MIME_ST_KEY ) );

	sf = g_strdup( gtk_entry_get_text( GTK_ENTRY(
		gtk_object_get_data( GTK_OBJECT( ww ), SUFFIXES_LIST_KEY ) ) ) );
		
	d = g_strdup( gtk_entry_get_text( GTK_ENTRY(
		gtk_object_get_data( GTK_OBJECT( ww ), DESCRIPTION_KEY ) ) ) );

	switch( ( s ? TRUE : FALSE ) )
	{	// update a mime
		case TRUE :
		{	gint	index, row;
						
			for( row = 0 ; row < list->rows ; row++ )
			{	if( MIME_ST( gtk_clist_get_row_data( list, row ) ) == s )
				{	if( mime_st_suffixes( s ) )
						g_free( mime_st_suffixes( s ) );
					mime_st_suffixes( s ) = sf;
			
					if( mime_st_desc( s ) )
						g_free( mime_st_desc( s ) );
					mime_st_desc( s ) = d;
					
					gtk_clist_set_text( list, row, COL_SUFFIXES, mime_st_suffixes( s ) );
					mime_st_edited( s ) = FALSE;
					gtk_widget_destroy( GTK_WIDGET( ww ) );
					
					// could submit
					gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), TRUE );

					return;
				}
			}
			// not found, add ( try ) a new one
		}
	
		case FALSE :
		{
			// try to add a new
			s = mime_st_new();
			mime_st_type( s ) = g_strdup( gtk_entry_get_text( GTK_ENTRY(
				gtk_object_get_data( GTK_OBJECT( ww ), MIME_TYPE_KEY ) ) ) );
			
			mime_st_suffixes( s ) = sf;		
			mime_st_desc( s ) = d;
	
			// test if error
			if( !real_add_mime( s ) )
			{	// warn can't add
				GtkWindow	*www =  GTK_WINDOW( gtk_window_new( GTK_WINDOW_DIALOG ) );
				GtkWidget	*b = gtk_vbox_new( FALSE, 5 );
				GtkWidget	*bp;
				
					gtk_container_add( GTK_CONTAINER( ww ), b );
					gtk_box_pack_start( GTK_BOX( b ), gtk_label_new( "Error with mime type" ), FALSE, FALSE, 5 );
					gtk_box_pack_start( GTK_BOX( b ), gtk_hseparator_new(), FALSE, FALSE, 5 );
					
					bp = gtk_button_new_with_label( "Close" );
					gtk_box_pack_start( GTK_BOX( b ), bp, FALSE, FALSE, 5 );
				
					gtk_signal_connect_object( GTK_OBJECT( bp ), "clicked", GTK_SIGNAL_FUNC( gtk_widget_destroy ), (gpointer)www );
					gtk_signal_connect( GTK_OBJECT( www ), "delete_event", GTK_SIGNAL_FUNC( gtk_widget_destroy ), NULL );
				
					gtk_widget_show_all( GTK_WIDGET( www ) );
				
					mime_st_destroy( s );
					return;
			}
			
			mime_st_edited( s ) = FALSE;

			// could submit
			gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), TRUE );

			// saved, exit
			gtk_widget_destroy( GTK_WIDGET( ww ) );
		}
	}	
}

/************************************************************************/
// abort change / add of this mime
static void cancel_popup_mime_view( GtkWindow *ww )
{
	gtk_widget_destroy( GTK_WIDGET( ww ) );
}

/************************************************************************/
// open dlg for mime
// one dlg per mime in idit mode
static void	popup_mime_view( mime_st *s )
{
GtkWindow	*ww = GTK_WINDOW( gtk_window_new( GTK_WINDOW_DIALOG ) );
GtkWidget	*b = gtk_vbox_new( FALSE, 5 );
GtkWidget	*b2 = gtk_hbox_new( TRUE, 5 );
GtkWidget	*bp;
GtkEntry	*e1, *e2, *e3;
	
	gtk_container_add( GTK_CONTAINER( ww ), b );
	
	gtk_box_pack_start( GTK_BOX( b ) , gtk_label_new( "Mime Type :" ), FALSE, FALSE, 5 );
	gtk_box_pack_start( GTK_BOX( b ) , GTK_WIDGET(  e1 = GTK_ENTRY( gtk_entry_new() ) ), FALSE, FALSE, 5 );
	gtk_object_set_data( GTK_OBJECT( ww ), MIME_TYPE_KEY, (gpointer)e1 );
	
	gtk_box_pack_start( GTK_BOX( b ) , gtk_label_new( "Suffixes List :" ), FALSE, FALSE, 5 );
	gtk_box_pack_start( GTK_BOX( b ) , GTK_WIDGET(  e2 = GTK_ENTRY( gtk_entry_new() ) ), FALSE, FALSE, 5 );
	gtk_object_set_data( GTK_OBJECT( ww ), SUFFIXES_LIST_KEY, (gpointer)e2 );

	gtk_box_pack_start( GTK_BOX( b ) , gtk_label_new( "Description :" ), FALSE, FALSE, 5 );
	gtk_box_pack_start( GTK_BOX( b ) , GTK_WIDGET(  e3 = GTK_ENTRY( gtk_entry_new() ) ), FALSE, FALSE, 5 );
	gtk_object_set_data( GTK_OBJECT( ww ), DESCRIPTION_KEY, (gpointer)e3 );

	gtk_box_pack_start( GTK_BOX( b ), gtk_hseparator_new(), FALSE, FALSE, 5 );
	gtk_box_pack_start( GTK_BOX( b ), b2, FALSE, FALSE, 5 );
	
	bp = gtk_button_new_with_label( "Ok" );
	gtk_box_pack_start( GTK_BOX( b2 ), bp, FALSE, FALSE, 5 );
	gtk_signal_connect_object( GTK_OBJECT( bp ), "clicked", GTK_SIGNAL_FUNC( save_popup_mime_view ), (gpointer)ww );
	
	bp = gtk_button_new_with_label( "Cancel" );
	gtk_box_pack_end( GTK_BOX( b2 ), bp, FALSE, FALSE, 5 );
	gtk_signal_connect_object( GTK_OBJECT( bp ), "clicked", GTK_SIGNAL_FUNC( save_popup_mime_view ), (gpointer)ww );
	
	gtk_signal_connect( GTK_OBJECT( ww ), "delete_event", GTK_SIGNAL_FUNC( save_popup_mime_view ), NULL );
	
	// fill with arg if provided
	if( s )
	{	mime_st_edited( s ) = TRUE;
		
		gtk_entry_set_text( e1, mime_st_type( s ) );
		gtk_entry_set_text( e2, mime_st_suffixes( s ) );
		gtk_entry_set_text( e3, mime_st_desc( s ) );
		
		gtk_object_set_data( GTK_OBJECT( ww ), MIME_ST_KEY, (gpointer)s );
		gtk_widget_set_sensitive( GTK_WIDGET( e1 ), FALSE );
	}
	
	
	gtk_widget_show_all( GTK_WIDGET( ww ) );
}

/************************************************************************/
// open dlg for mime
static gboolean add_mime()
{
}

/************************************************************************/
static void select_callback( GtkCList *cl, gint r, gint c, GdkEventButton *b, gpointer d )
{
	gtk_widget_set_sensitive( GTK_WIDGET( bp_edit ), TRUE );
	gtk_widget_set_sensitive( GTK_WIDGET( bp_delete ), TRUE );
}

/************************************************************************/
static void unselect_callback( GtkCList *cl, gint r, gint c, GdkEventButton *b, gpointer d )
{
	gtk_widget_set_sensitive( GTK_WIDGET( bp_edit ), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET( bp_delete ), FALSE );
}

/************************************************************************/
static void add_callback( GtkWidget *bp )
{
	popup_mime_view( NULL );
}

/************************************************************************/
static void delete_callback( GtkWidget *bp )
{
mime_st	*s;
	
	if( !list->selection->data )
		return;

	s = MIME_ST( gtk_clist_get_row_data( list, (gint)(list->selection->data) ) );
	
	if( mime_st_edited( s ) )
		return;
	
	mime_st_destroy( s );
	
	gtk_clist_remove( list, (gint)(list->selection->data) );
}

/************************************************************************/
static void edit_callback( GtkWidget *bp )
{	
mime_st	*s;

	if( !list->selection->data )
		return;
	
	s = MIME_ST( gtk_clist_get_row_data( list, (gint)(list->selection->data) ) );

	if( mime_st_edited( s ) )
		return;
	
	popup_mime_view( s );
}

/************************************************************************/
static void help_callback( GtkWidget *bp )
{
#ifdef HAVE_MOZILLA
static char	 const *argv[] = { "mozilla", "file:"PACKAGE_DOC_DIR"/"GBP_CONFIG_PAGE_PATH, NULL };
#else
static char	 const *argv[] = { "netscape", "file:"PACKAGE_DOC_DIR"/"GBP_CONFIG_PAGE_PATH, NULL };
#endif	

pid_t	pid, ppid = getpid();
int		status;
	
	signal( SIGCHLD, SIG_IGN );								// prevent zombie
	
	if( !( pid = fork() ) )									// don't test for pid owerflow...
	{	int	status;

		// child
		waitpid( pid, &status, 0 );

		setpgid( 0, 0 );
		setsid();											// set to background

		execvp( argv[0], argv );							// start the command
		perror( "Can't launch application...\n" );
		_exit( 1 );
	}	
}

/************************************************************************/
static use_gnome_toggled( GtkWidget *widget, gpointer p )
{
	gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), TRUE );
}

/************************************************************************/
int main( int argc, char *argv[] )
{
GtkWindow			*w;	
GtkBox				*b, *b2;
GtkScrolledWindow	*sc;
	
	gtk_init( &argc, &argv );
     
	w = GTK_WINDOW( gtk_window_new( GTK_WINDOW_TOPLEVEL ) );
	b = GTK_BOX( gtk_vbox_new( FALSE, 5 ) );
	gtk_container_add( GTK_CONTAINER( w ), GTK_WIDGET( b ) );
	gtk_widget_set_usize( GTK_WIDGET( w ), 500, 475 );
	
	// top text info
	gtk_box_pack_start( b, gtk_label_new( TEXT_INFO ), FALSE, TRUE, 5 );
	gtk_box_pack_start( b, gtk_hseparator_new(), FALSE, TRUE, 0 );
	
	// list of mime...
	gtk_box_pack_start( b, gtk_label_new( "Mime handled by this plug-in" ), FALSE, FALSE, 5 );
	gtk_scrolled_window_set_policy( ( sc = GTK_SCROLLED_WINDOW( gtk_scrolled_window_new( NULL, NULL ) ) ),
		GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC );
	
	// set clist policy and events
	list = GTK_CLIST( gtk_clist_new_with_titles( 2, title ) );
	gtk_container_add( GTK_CONTAINER( sc ), GTK_WIDGET( list ) );
	gtk_clist_set_column_auto_resize( list, COL_TYPE, TRUE );
	gtk_clist_set_column_auto_resize( list, COL_SUFFIXES, TRUE );
	gtk_clist_set_selection_mode( list, GTK_SELECTION_SINGLE );

	gtk_box_pack_start( b, GTK_WIDGET( sc ), TRUE, TRUE, 5 );

	// button box for mime action
	b2 = GTK_BOX( gtk_hbox_new( FALSE, 5 ) );
	bp_add = GTK_BUTTON( gtk_button_new_with_label( "Add" ) );
	bp_delete = GTK_BUTTON( gtk_button_new_with_label( "Delete" ) );
	bp_edit = GTK_BUTTON( gtk_button_new_with_label( "Edit" ) );
	gtk_widget_set_sensitive( GTK_WIDGET( bp_delete ), FALSE );
	gtk_widget_set_sensitive( GTK_WIDGET( bp_edit ), FALSE );
	gtk_box_pack_start( b2, GTK_WIDGET( bp_add ), FALSE, FALSE, 5 );
	gtk_box_pack_start( b2, GTK_WIDGET( bp_edit ), FALSE, FALSE, 5 );
	gtk_box_pack_end( b2, GTK_WIDGET( bp_delete ), FALSE, FALSE, 5 );

	gtk_box_pack_start( b, GTK_WIDGET( b2 ), FALSE, TRUE, 5 );
	gtk_box_pack_start( b, gtk_hseparator_new(), FALSE, TRUE, 0 );

	// global options
	use_gnome = GTK_CHECK_BUTTON( gtk_check_button_new_with_label( "use gnome dialog instead of status bar for messages" ) );
	gtk_box_pack_start( b, GTK_WIDGET( use_gnome ), FALSE, FALSE, 0 );	
	gtk_box_pack_start( b, gtk_hseparator_new(), FALSE, TRUE, 0 );
	
	// bp box
	b2 = GTK_BOX( gtk_hbox_new( FALSE, 5 ) );
	bp_help = GTK_BUTTON( gtk_button_new_with_label( "Help !!" ) );
	bp_submit = GTK_BUTTON( gtk_button_new_with_label( "Submit" ) );
	gtk_widget_set_sensitive( GTK_WIDGET( bp_submit ), FALSE );

	gtk_box_pack_start( b2, GTK_WIDGET( bp_help ), FALSE, FALSE, 5 );
	gtk_box_pack_end( b2, GTK_WIDGET( bp_submit ), FALSE, FALSE, 5 );
	gtk_box_pack_start( b, GTK_WIDGET( b2 ), FALSE, FALSE, 5 );
		
	// set all events
	gtk_signal_connect( GTK_OBJECT( list ), "select-row", GTK_SIGNAL_FUNC ( select_callback ), NULL );
	gtk_signal_connect( GTK_OBJECT( list ), "unselect-row", GTK_SIGNAL_FUNC ( unselect_callback ), NULL );

	gtk_signal_connect( GTK_OBJECT( bp_add ), "clicked", GTK_SIGNAL_FUNC( add_callback ), NULL );
	gtk_signal_connect( GTK_OBJECT( bp_delete ), "clicked", GTK_SIGNAL_FUNC( delete_callback ), NULL );
	gtk_signal_connect( GTK_OBJECT( bp_edit ), "clicked", GTK_SIGNAL_FUNC( edit_callback ), NULL );

	gtk_signal_connect( GTK_OBJECT( bp_help ), "clicked", GTK_SIGNAL_FUNC( help_callback ), NULL );
	gtk_signal_connect( GTK_OBJECT( bp_submit ), "clicked", GTK_SIGNAL_FUNC( save_config ), NULL );
	
	gtk_signal_connect( GTK_OBJECT( w ), "destroy", GTK_SIGNAL_FUNC( gtk_main_quit ), NULL );
	gtk_signal_connect( GTK_OBJECT( w ), "delete_event", GTK_SIGNAL_FUNC( exit_window ), NULL );

	gtk_signal_connect( GTK_OBJECT( use_gnome ), "toggled", GTK_SIGNAL_FUNC( use_gnome_toggled ), NULL );

	gtk_widget_show_all( GTK_WIDGET( w ) );
	
	// load config
	if( !load_config() )
		init_config();						// no config, fill with default
		
	gtk_main();
	return( 0 );
}