/************************************************************************/
//		plug-in for internet browser ( mozilla / netscape )
//		send enbled url to downloader gsfdm through corba bus

//		j.a.l@free.fr

/************************************************************************/

#include	<signal.h>
#include	<unistd.h>
#include	<sys/wait.h>
#include	<sys/types.h>
#include	<bits/types.h>
#include	<stdio.h>
#include	<fcntl.h>
#include	<errno.h>
#include	"utils.h"
#include	"./include/npapi.h"

#define MAX_LOOP_FOR_WAITING		360

/************************************************************************/
// launch command ; simplified version just for THIS soft
// ---> no parse, set in background, don't wait...
pid_t	gbp_launch_command( char const **argv, NPBool wait )
{
pid_t	pid, ppid = getpid();
FILE	*fd;
int		count = MAX_LOOP_FOR_WAITING;

	signal( SIGCHLD, SIG_IGN );								// prevent zombie
	
	if( !( pid = fork() ) )									// don't test for pid owerflow...
	{	int	status;

		// netscape is listenning... try without...
		fclose( stdin );
		fclose( stderr );
		fclose( stdout );
		
		// child
//		waitpid( pid, &status, 0 );
//		setpgid( 0, 0 );
	
		setsid();											// set to background

		execvp( argv[0], argv );							// start the command
		perror( "Can't launch application...\n" );
		_exit( 1 );
	}

	// parent, wait child ready
	// use proc, read status from child's pid, until 'running'
	if( wait )
	{	static char	*buf = NULL;
		static char	path[100];
		FILE	*FF;
		size_t	size = 300;

		snprintf( path, 100, "/proc/%d/status", pid );

		if( !access( path, F_OK ) )
		{	
			buf = malloc( 300 );
			do {
				FF = fopen( path, "r" );
	
				getline( &buf, &size, FF );
				getline( &buf, &size, FF );

				fclose( FF );
			} while( strstr( buf, "running" ) );
			free( buf );
		
		} else {
			sleep( 5 );			// no proc ?? well, use a timer
		}		
	}
	
	return( pid );
}


/* old solution
// **************************************************************************
// launch command ; simplified version just for THIS soft
// ---> no parse, set in background, don't wait...
pid_t	gbp_launch_command( char const **argv, NPBool wait )
{
pid_t	pid, ppid = getpid();
int		p[2];
FILE	*fd;
int		count = MAX_LOOP_FOR_WAITING;
int	c;

	signal( SIGCHLD, SIG_IGN );								// prevent zombie
	
	if( wait )
		pipe( p );
	
	if( !( pid = fork() ) )									// don't test for pid owerflow...
	{	int	status;

		// netscape is listenning... try without...
		fclose( stdin );
		fclose( stderr );
		fclose( stdout );

		// use a pipe for com with parent
		if( wait )
		{	dup2( p[ STDOUT_FILENO ], STDOUT_FILENO );
			close( p[ STDIN_FILENO ] );
		}
		
		// child
		waitpid( pid, &status, 0 );

		setpgid( 0, 0 );
		setsid();											// set to background

		execvp( argv[0], argv );							// start the command
		perror( "Can't launch application...\n" );
		_exit( 1 );
	}
	
	// parent, wait child ready for i/o
	// NOTA : inspired by glib and goad
	if( wait )
	{ int	c;
		
		close( p[ STDOUT_FILENO ] );
		fcntl(  p[ STDIN_FILENO ], F_SETFL, O_NONBLOCK );
		fd = fdopen( p[ STDIN_FILENO ], "r" );
	
		do{ 
			c = fgetc( fd );
			count--; 
			sleep( 1 );
		} while( ferror( fd ) && count && ( c == -1 ) );
			
		fclose( fd );
		close( p[ STDIN_FILENO ] );
	}
	
//	waitpid( pid, NULL, WUNTRACED );

	return( pid );
}


*/










